unit ActorUnit;

interface

uses Classes, SysUtils, ThingUnit, ThingHolderUnit, RoomUnit;

type
  Actor = class(ThingHolder)
  private
    _location: integer;
  public
    constructor Create(aName, aDescription: shortstring; aLocation: integer);
    destructor Destroy; override;
    property Location: integer read _location write _location;
    procedure WriteToStream(fs: TFileStream); override;
    procedure ReadFromStream(fs: TFileStream); override;
  end;

implementation

constructor Actor.Create(aName, aDescription: shortstring; aLocation: integer);
begin
  inherited Create(aName, aDescription);
  _location := aLocation;
end;

destructor Actor.Destroy;
begin
  inherited Destroy;
end;

procedure Actor.WriteToStream(fs: TFileStream);
begin
  inherited WriteToStream(fs);
  fs.WriteBuffer(_location, sizeof(_location));
end;

procedure Actor.ReadFromStream(fs: TFileStream);
begin
  inherited ReadFromStream(fs);
  fs.ReadBuffer(_location, sizeof(_location));
end;

end.
