unit ImplementerUnit;



interface

uses
  Windows, Messages, SysUtils, Classes, StdCtrls, ComCtrls,
  AdvConstsUnit, RoomUnit, RoomListUnit, ActorUnit ;

type
Implementer = class(TObject)
    constructor Create;
    destructor Destroy; override;
    function MoveTo(var anActor: Actor; aDir: integer;
      var aMap: RoomList): string;
    function SaveGame(player: Actor; aMap: RoomList; aFileName: string): boolean;
    function LoadGame(var player: Actor; var aMap: RoomList;
      aFileName: string): boolean;
  end;

implementation
constructor Implementer.Create;
begin
  inherited Create;
end;

destructor Implementer.Destroy;
begin
  inherited Destroy;
end;

function Implementer.SaveGame(player: Actor; aMap: RoomList;
  aFileName: string): boolean;
var
  fs: TFileStream;
  ok: boolean;
begin
  ok := true;
  fs := TFileStream.Create(aFileName, fmCreate);
  try
    try
      aMap.WriteToStream(fs);
      player.WriteToStream(fs);
    except
      on Exception do
        ok := false;
    end;
  finally
    fs.Free;
  end;
  result := ok;
end;

function Implementer.LoadGame(var player: Actor; var aMap: RoomList;
  aFileName: string): boolean;
var
  fs: TFileStream;
  ok: boolean;
  currentClassName: shortstring;
begin
  ok := true;
  fs := TFileStream.Create(aFileName, fmOpenRead);
  aMap.Free;
  aMap := RoomList.Create('Temp Map', 'Map prior to loading data');
  player.Free;
  player := Actor.Create('Temp ActorOb', 'A Temp Player', 0);
  try
    fs.ReadBuffer(currentClassName, sizeof(currentClassName));
    // read class name
    try
      aMap.ReadFromStream(fs);
      fs.ReadBuffer(currentClassName, sizeof(currentClassName));
      // read class name
      player.ReadFromStream(fs);
    except
      on Exception do
        ok := false;
    end;
  finally
    fs.Free;
  end;
  result := ok;
end;

function Implementer.MoveTo(var anActor: Actor; aDir: integer;
  var aMap: RoomList): string;
// attempt to move actorob in direction of dir. Return msg indicating
// success or otherwise
var
  pos: integer;
  r: Room;
  exit: integer;
  msg: string;
begin
  msg := 'Error: Oops! Cannot move there!'; // some unknown problem
  pos := anActor.Location;
  r := Room(aMap._things.Items[pos]);
  case (aDir) of
    NORTH:
      exit := r.N;
    SOUTH:
      exit := r.S;
    WEST:
      exit := r.W;
    EAST:
      exit := r.E;
  else
    exit := NOEXIT;
  end;
  if exit = NOEXIT then
    msg := 'No Exit!'
  else
  begin
    anActor.Location := exit;
    msg := 'Exit to Room: ' + IntToStr(exit);
  end;
  result := msg;
end;

end.
