unit RoomUnit;

interface

uses Classes, SysUtils, ThingUnit, ThingHolderUnit;

type
  Room = class(ThingHolder)
  private
    _n, _s, _w, _e: integer;
  public
    constructor Create(aName, aDescription: shortstring;
      aNorth, aSouth, aWest, anEast: integer);
    destructor Destroy; override;
    property N: integer read _n write _n;
    property S: integer read _s write _s;
    property W: integer read _w write _w;
    property E: integer read _e write _e;
    procedure WriteToStream(fs: TFileStream); override;
    procedure ReadFromStream(fs: TFileStream); override;
  end;

implementation

{ === ROOM === }
constructor Room.Create(aName, aDescription: shortstring;
  aNorth, aSouth, aWest, anEast: integer);
begin
  inherited Create(aName, aDescription);
  _n := aNorth;
  _s := aSouth;
  _w := aWest;
  _e := anEast;
end;

destructor Room.Destroy;
begin
  inherited Destroy;
end;

procedure Room.WriteToStream(fs: TFileStream);
begin
  inherited WriteToStream(fs);
  fs.WriteBuffer(_n, sizeof(_n));
  fs.WriteBuffer(_s, sizeof(_s));
  fs.WriteBuffer(_w, sizeof(_w));
  fs.WriteBuffer(_e, sizeof(_e));
end;

procedure Room.ReadFromStream(fs: TFileStream);
begin
  inherited ReadFromStream(fs);
  fs.ReadBuffer(_n, sizeof(_n));
  fs.ReadBuffer(_s, sizeof(_s));
  fs.ReadBuffer(_w, sizeof(_w));
  fs.ReadBuffer(_e, sizeof(_e));
end;

end.
