unit ThingUnit;

interface

uses Classes, SysUtils;

type
  Thing = class(TObject)
  private // hide data
    _name: shortstring;
    _description: shortstring;
  public
    constructor Create(aName, aDescription: shortstring);
    constructor CreateFromStream(fs: TFileStream);
    destructor Destroy; override;
    property Name: shortstring read _name write _name;
    property Description: shortstring read _description write _description;
    procedure WriteToStream(fs: TFileStream); virtual; // !! stream handling
    procedure ReadFromStream(fs: TFileStream); virtual;
  end;

implementation

constructor Thing.Create(aName, aDescription: shortstring);
begin
  inherited Create;
  _name := aName;
  _description := aDescription;
end;

destructor Thing.Destroy;
begin
  inherited Destroy;
end;

procedure Thing.WriteToStream(fs: TFileStream);
var
  currentClassName: shortstring;
begin
  currentClassName := self.classname;
  fs.WriteBuffer(currentClassName, sizeof(currentClassName));
  fs.WriteBuffer(_name, sizeof(_name));
  fs.WriteBuffer(_description, sizeof(_description));
end;

procedure Thing.ReadFromStream(fs: TFileStream);
begin
  fs.ReadBuffer(_name, sizeof(_name));
  fs.ReadBuffer(_description, sizeof(_description));
end;

constructor Thing.CreateFromStream(fs: TFileStream);
// !! Note: Since ReadFromStream is a virtual/overridden method, a call
// such as RoomOb.CreateFromSteam will actually execute the
// RoomOb version of ReadFromStream
begin
  inherited Create;
  ReadFromStream(fs);
end;
end.
